package cokr.xit.fims.mngt.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.mngt.Vltn;
import cokr.xit.fims.mngt.VltnQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 위반 정보 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-10-16	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("vltnMapper")
public interface VltnMapper extends AbstractMapper {
	/**지정한 조건에 따라 위반 정보 목록을 조회하여 반환한다.<br />
	 * @param req 위반 정보 조회 조건
	 * @return 위반 정보 목록
	 */
	List<DataObject> selectVltnList(VltnQuery req);

	/**지정한 조건에 따라 위반 정보 객체들을 반환한다.
	 * @param req 위반 정보 조회 조건
	 * @return 위반 정보 객체 목록
	 */
	List<DataObject> selectVltns(VltnQuery req);

	/**지정한 조건에 따라 위반 정보 객체를 반환한다.
	 * @param req 위반 정보 조회 조건
	 * @return 위반 정보 객체
	 */
	default DataObject selectVltnInfo(VltnQuery req) {
		List<DataObject> vltns = selectVltns(req);

		return !vltns.isEmpty() ? vltns.get(0) : null;
	}

	/**위반 정보 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"vltnInfo" - 위반 정보</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertVltn(Map<String, Object> params);

	/**위반 정보 정보를 등록한다.
	 * @param vltnInfo 위반 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(Vltn vltn) {
		return vltn != null && insertVltn(params().set("vltn", vltn)) == 1;
	}

	/**위반 정보 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"vltnInfo" - 위반 정보</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateVltn(Map<String, Object> params);

	/**위반 정보 정보를 수정한다.
	 * @param vltnInfo 위반 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(Vltn vltn) {
		return vltn != null && updateVltn(params().set("vltn", vltn)) == 1;
	}

	/**지정한 위반 정보을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"vltnInfo" - 위반 정보</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteVltn(Map<String, ?> params);

	/**위반 정보 정보를 삭제한다.
	 * @param vltnInfo 위반 정보
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(Vltn vltn) {
		return vltn != null && deleteVltn(params().set("vltn", vltn)) == 1;
	}

}
